<template>
  <div class="wrapper">
    <label>
      <input
          placeholder="Search..."
          type="text"
          v-model="searchValue"
          @input="onChanged"
      />
      <ul
          v-if="searchValue && searchValue.length > 0"
          id="search-entry-list"
          class="search-entry-list"
      >
      <li
          v-for="(result, i) in suggestions"
          :key="i"
          @click="onSelected(result)"
          class="search-entry"
      >
        <p>{{ result.name }}<p>
        <p>{{ result.distance }}</p>
      </li>
      </ul>
    </label>
  </div>
</template>
<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'SearchAutocomplete',
  props: {
    suggestions: {
      type: Array,
      required: false,
      default: () => [],
    },
    trigger: {
      type: Function,
      required: false,
      default: () => null,
    },
    onSelected: {
      type: Function,
      required: false,
      default: () => null,
    },
  },
  data() {
    return {
      searchValue: '',
    };
  },
  methods: {
    onChanged() {
      this.$emit('input', this.searchValue);
      this.trigger(this.searchValue);
    },
  },
});
</script>
<style>
.wrapper {
  position: relative;
  max-width: 400px;
  margin: auto;
}
input[type=text] {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  box-sizing: border-box;
  border: 2px solid grey;
  border-radius: 8px;
  font-size: 1.1rem;
  transition: ease-in-out, width .35s ease-in-out;
}
input[type=text]:focus {
  outline: none;
  border: 2px solid #4AAE9B;
}

.search-entry-list {
  padding: 0;
  margin: 0;
  border: 1px solid #eeeeee;
  height: 260px;
  overflow: auto;
}
.search-entry {
  list-style: none;
  text-align: left;
  padding: 0px 10px;
  cursor: pointer;
  border-radius: 4px;
  display: flex;
  justify-content: space-between;
}
.search-entry:hover {
  background-color: #4AAE9B;
  color: white;
}
</style>
